"use strict";
var tslib_1 = require("tslib");
require("core-js/es6");
require("core-js/es7/reflect");
require("zone.js/dist/zone");
var platform_browser_dynamic_1 = require("@angular/platform-browser-dynamic");
var core_1 = require("@angular/core");
core_1.enableProdMode();
var core_2 = require("@angular/core");
var data_1 = require("../data");
var MainComponent = (function () {
    function MainComponent() {
        this.data = data_1.data;
        this.selectedId = null;
    }
    MainComponent.prototype.ontoggle = function (eventData) {
        eventData.data.state.opened = !eventData.data.state.opened;
    };
    MainComponent.prototype.onchange = function (eventData) {
        this.selectedId = eventData.data.state.selected ? null : eventData.data.value.id;
        if (!eventData.data.state.selected) {
            this.clearSelection();
        }
        eventData.data.state.selected = !eventData.data.state.selected;
    };
    MainComponent.prototype.clearSelectionOfTree = function (tree) {
        if (tree.state.selected) {
            tree.state.selected = false;
        }
        if (tree.children) {
            for (var _i = 0, _a = tree.children; _i < _a.length; _i++) {
                var child = _a[_i];
                this.clearSelectionOfTree(child);
            }
        }
    };
    MainComponent.prototype.clearSelection = function () {
        for (var _i = 0, _a = this.data; _i < _a.length; _i++) {
            var child = _a[_i];
            this.clearSelectionOfTree(child);
        }
    };
    return MainComponent;
}());
MainComponent = tslib_1.__decorate([
    core_2.Component({
        selector: "app",
        template: "\n    <tree [data]=\"data\"\n        (toggle)=\"ontoggle($event)\"\n        (change)=\"onchange($event)\"></tree>\n    selected id: {{selectedId}}\n    ",
    })
], MainComponent);
exports.MainComponent = MainComponent;
var core_3 = require("@angular/core");
var platform_browser_1 = require("@angular/platform-browser");
var forms_1 = require("@angular/forms");
var angular_1 = require("../../dist/angular");
var MainModule = (function () {
    function MainModule() {
    }
    return MainModule;
}());
MainModule = tslib_1.__decorate([
    core_3.NgModule({
        imports: [platform_browser_1.BrowserModule, forms_1.FormsModule],
        declarations: [MainComponent, angular_1.NodeComponent, angular_1.TreeComponent],
        bootstrap: [MainComponent],
    })
], MainModule);
platform_browser_dynamic_1.platformBrowserDynamic().bootstrapModule(MainModule);
