"use strict";
var tslib_1 = require("tslib");
var React = require("react");
var ReactDOM = require("react-dom");
var react_1 = require("../../dist/react");
var data_1 = require("../data");
var Main = (function (_super) {
    tslib_1.__extends(Main, _super);
    function Main() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.data = data_1.data;
        _this.selectedId = null;
        return _this;
    }
    Main.prototype.render = function () {
        var _this = this;
        return (React.createElement("div", null,
            React.createElement(react_1.Tree, { data: data_1.data, toggle: function (eventData) { return _this.toggle(eventData); }, change: function (eventData) { return _this.change(eventData); } }),
            "selected id: ",
            this.selectedId));
    };
    Main.prototype.toggle = function (eventData) {
        eventData.data.state.opened = !eventData.data.state.opened;
        this.setState({ data: this.data });
    };
    Main.prototype.change = function (eventData) {
        this.selectedId = eventData.data.state.selected ? null : eventData.data.value.id;
        this.setState({ selectedId: this.selectedId });
        if (!eventData.data.state.selected) {
            this.clearSelection();
        }
        eventData.data.state.selected = !eventData.data.state.selected;
        this.setState({ data: this.data });
    };
    Main.prototype.clearSelectionOfTree = function (tree) {
        if (tree.state.selected) {
            tree.state.selected = false;
        }
        if (tree.children) {
            for (var _i = 0, _a = tree.children; _i < _a.length; _i++) {
                var child = _a[_i];
                this.clearSelectionOfTree(child);
            }
        }
    };
    Main.prototype.clearSelection = function () {
        for (var _i = 0, _a = this.data; _i < _a.length; _i++) {
            var child = _a[_i];
            this.clearSelectionOfTree(child);
        }
        this.setState({ data: this.data });
    };
    return Main;
}(React.Component));
ReactDOM.render(React.createElement(Main, null), document.getElementById("container"));
