"use strict";
var Vue = require("vue");
require("../../dist/vue");
var data_1 = require("../data");
/* tslint:disable:no-unused-new */
new Vue({
    el: "#container",
    data: function () {
        return {
            data: data_1.data,
            selectedId: null,
        };
    },
    methods: {
        toggle: function (eventData) {
            eventData.data.state.opened = !eventData.data.state.opened;
        },
        change: function (eventData) {
            this.selectedId = eventData.data.state.selected ? null : eventData.data.value.id;
            if (!eventData.data.state.selected) {
                this.clearSelection();
            }
            eventData.data.state.selected = !eventData.data.state.selected;
        },
        clearSelectionOfTree: function (tree) {
            if (tree.state.selected) {
                tree.state.selected = false;
            }
            if (tree.children) {
                for (var _i = 0, _a = tree.children; _i < _a.length; _i++) {
                    var child = _a[_i];
                    this.clearSelectionOfTree(child);
                }
            }
        },
        clearSelection: function () {
            for (var _i = 0, _a = this.data; _i < _a.length; _i++) {
                var child = _a[_i];
                this.clearSelectionOfTree(child);
            }
        },
    },
});
