"use strict";
require("tslib");
var DoubleClick = (function () {
    function DoubleClick(timeout) {
        if (timeout === void 0) { timeout = 300; }
        this.timeout = timeout;
        this.clicked = false;
    }
    DoubleClick.prototype.onclick = function (singleClick) {
        var _this = this;
        if (!this.clicked) {
            this.clicked = true;
            singleClick();
            setTimeout(function () {
                _this.clicked = false;
            }, this.timeout);
        }
    };
    return DoubleClick;
}());
exports.DoubleClick = DoubleClick;
function getNodeClassName(data, last) {
    var values = ["jstree-node"];
    if (data.children && data.children.length > 0) {
        if (data.state.opened) {
            values.push("jstree-open");
        }
        else {
            values.push("jstree-closed");
        }
    }
    else {
        values.push("jstree-leaf");
    }
    if (last) {
        values.push("jstree-last");
    }
    return values.join(" ");
}
exports.getNodeClassName = getNodeClassName;
function getAnchorClassName(data, hovered) {
    var values = ["jstree-anchor"];
    if (data.state.selected) {
        values.push("jstree-clicked");
    }
    if (data.state.disabled) {
        values.push("jstree-disabled");
    }
    if (hovered) {
        values.push("jstree-hovered");
    }
    return values.join(" ");
}
exports.getAnchorClassName = getAnchorClassName;
//# sourceMappingURL=common.js.map