"use strict";
var tslib_1 = require("tslib");
var React = require("react");
var common = require("./common");
var Node = (function (_super) {
    tslib_1.__extends(Node, _super);
    function Node() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.hovered = false;
        _this.doubleClick = new common.DoubleClick();
        return _this;
    }
    Node.prototype.render = function () {
        var _this = this;
        var childrenElement;
        if (this.props.data.children) {
            var nodesElement = this.props.data.children.map(function (child, i) { return (React.createElement(Node, { data: child, last: i === _this.props.data.children.length - 1, toggle: function (eventData) { return _this.ontoggle(eventData); }, change: function (eventData) { return _this.onchange(eventData); } })); });
            childrenElement = (React.createElement("ul", { role: "group", className: "jstree-children" }, nodesElement));
        }
        else {
            childrenElement = null;
        }
        return (React.createElement("li", { role: "treeitem", className: this.nodeClassName },
            React.createElement("i", { className: "jstree-icon jstree-ocl", role: "presentation", onClick: function () { return _this.ontoggle(); } }),
            React.createElement("a", { className: this.anchorClassName, href: "javascript:void(0)", onClick: function () { return _this.onchange(); }, onDoubleClick: function () { return _this.ontoggle(); }, onMouseEnter: function () { return _this.hover(true); }, onMouseLeave: function () { return _this.hover(false); } },
                React.createElement("i", { className: "jstree-icon jstree-themeicon", role: "presentation" }),
                this.props.data.text),
            childrenElement));
    };
    Object.defineProperty(Node.prototype, "nodeClassName", {
        get: function () {
            return common.getNodeClassName(this.props.data, this.props.last);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Node.prototype, "anchorClassName", {
        get: function () {
            return common.getAnchorClassName(this.props.data, this.hovered);
        },
        enumerable: true,
        configurable: true
    });
    Node.prototype.hover = function (hovered) {
        this.hovered = hovered;
        this.setState({ hovered: this.hovered });
    };
    Node.prototype.ontoggle = function (eventData) {
        if (eventData) {
            this.props.toggle(eventData);
        }
        else {
            if (this.props.data.children && this.props.data.children.length > 0) {
                this.props.toggle({ data: this.props.data });
            }
        }
    };
    Node.prototype.onchange = function (eventData) {
        var _this = this;
        if (eventData) {
            this.props.change(eventData);
        }
        else {
            if (this.props.data.state.disabled) {
                return;
            }
            this.doubleClick.onclick(function () {
                _this.props.change({ data: _this.props.data });
            });
        }
    };
    return Node;
}(React.Component));
var Tree = (function (_super) {
    tslib_1.__extends(Tree, _super);
    function Tree() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Tree.prototype.render = function () {
        var _this = this;
        var childrenElement = this.props.data.map(function (child, i) { return (React.createElement(Node, { data: child, last: i === _this.props.data.length - 1, toggle: function (data) { return _this.ontoggle(data); }, change: function (data) { return _this.onchange(data); } })); });
        return (React.createElement("div", { className: "jstree jstree-default jstree-default-dark", role: "tree" },
            React.createElement("ul", { className: "jstree-container-ul jstree-children", role: "group" }, childrenElement)));
    };
    Tree.prototype.ontoggle = function (eventData) {
        if (this.props.toggle) {
            this.props.toggle(eventData);
        }
    };
    Tree.prototype.onchange = function (eventData) {
        if (this.props.change) {
            this.props.change(eventData);
        }
    };
    return Tree;
}(React.Component));
exports.Tree = Tree;
//# sourceMappingURL=react.js.map