"use strict";
var tslib_1 = require("tslib");
var Vue = require("vue");
var vue_class_component_1 = require("vue-class-component");
var common = require("./common");
var Node = (function (_super) {
    tslib_1.__extends(Node, _super);
    function Node() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.hovered = false;
        _this.doubleClick = new common.DoubleClick();
        return _this;
    }
    Object.defineProperty(Node.prototype, "nodeClassName", {
        get: function () {
            return common.getNodeClassName(this.data, this.last);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Node.prototype, "anchorClassName", {
        get: function () {
            return common.getAnchorClassName(this.data, this.hovered);
        },
        enumerable: true,
        configurable: true
    });
    Node.prototype.hover = function (hovered) {
        this.hovered = hovered;
    };
    Node.prototype.ontoggle = function (eventData) {
        if (eventData) {
            this.$emit("toggle", eventData);
        }
        else {
            if (this.data.children && this.data.children.length > 0) {
                this.$emit("toggle", { data: this.data });
            }
        }
    };
    Node.prototype.onchange = function (eventData) {
        var _this = this;
        if (eventData) {
            this.$emit("change", eventData);
        }
        else {
            if (this.data.state.disabled) {
                return;
            }
            this.doubleClick.onclick(function () {
                _this.$emit("change", { data: _this.data });
            });
        }
    };
    return Node;
}(Vue));
Node = tslib_1.__decorate([
    vue_class_component_1.default({
        template: "\n    <li role=\"treeitem\" :class=\"nodeClassName\">\n        <i class=\"jstree-icon jstree-ocl\" role=\"presentation\" @click=\"ontoggle()\"></i><a :class=\"anchorClassName\" href=\"javascript:void(0)\" @click=\"onchange()\" @dblclick=\"ontoggle()\" @mouseenter=\"hover(true)\" @mouseleave=\"hover(false)\"><i class=\"jstree-icon jstree-themeicon\" role=\"presentation\"></i>{{data.text}}</a>\n        <ul v-if=\"data.children\" role=\"group\" class=\"jstree-children\">\n            <node v-for=\"(child, i) in data.children\"\n                :data=\"child\"\n                :last=\"i === data.children.length - 1\"\n                @toggle=\"ontoggle(arguments[0])\"\n                @change=\"onchange(arguments[0])\">\n            </node>\n        </ul>\n    </li>\n    ",
        props: ["data", "last"],
    })
], Node);
Vue.component("node", Node);
var Tree = (function (_super) {
    tslib_1.__extends(Tree, _super);
    function Tree() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Tree.prototype.ontoggle = function (eventData) {
        this.$emit("toggle", eventData);
    };
    Tree.prototype.onchange = function (eventData) {
        this.$emit("change", eventData);
    };
    return Tree;
}(Vue));
Tree = tslib_1.__decorate([
    vue_class_component_1.default({
        template: "\n    <div class=\"jstree jstree-default jstree-default-dark\" role=\"tree\">\n        <ul class=\"jstree-container-ul jstree-children\" role=\"group\">\n            <node v-for=\"(child, i) in data\"\n                :data=\"child\"\n                :last=\"i === data.length - 1\"\n                @toggle=\"ontoggle(arguments[0])\"\n                @change=\"onchange(arguments[0])\"></node>\n        </ul>\n    </div>\n    ",
        props: ["data"],
    })
], Tree);
exports.Tree = Tree;
Vue.component("tree", Tree);
//# sourceMappingURL=vue.js.map